#ifndef LIST_MANAGER
#define LIST_MANAGER

#include <stdlib.h>
#include <stdio.h>

#include "icon.hpp"

class DisplayListNode {

	friend class DisplayList;
	DisplayListNode* predecessor;
	DisplayListNode* successor;
	Icon* entry;

public:

	DisplayListNode(Icon* item);
};

class DisplayList {

private:

	friend class DisplayListNode;
	DisplayListNode* first_item;
	DisplayListNode* current_item;
	long list_length;

	void DeleteCurrentNode();
	void FatalListError(char*);

public:

	DisplayList();
	long Size() {return list_length;}
	void AddItem(Icon* item);
	void RemoveItem(Icon* item);
	Icon* CurrentItem();
	void NextItem() {current_item = 
				  current_item->successor;}
	void operator++() {NextItem();}
	void operator--() {current_item = 
				    current_item->predecessor;}
	void GotoBeginning();
	void GotoEnd();
	~DisplayList();
};

#endif
